(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('prosemirror-commands'), require('ngx-editor/helpers'), require('prosemirror-schema-list')) :
    typeof define === 'function' && define.amd ? define('ngx-editor/commands', ['exports', 'prosemirror-commands', 'ngx-editor/helpers', 'prosemirror-schema-list'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ngx-editor'] = global['ngx-editor'] || {}, global['ngx-editor'].commands = {}), global.prosemirrorCommands, global['ngx-editor'].helpers, global.prosemirrorSchemaList));
}(this, (function (exports, prosemirrorCommands, helpers, prosemirrorSchemaList) { 'use strict';

    var toggleBlockType = function (type, toggleType, attrs) {
        if (attrs === void 0) { attrs = {}; }
        return function (state, dispatch) {
            var isActive = helpers.isNodeActive(state, type, attrs);
            if (isActive) {
                return prosemirrorCommands.setBlockType(toggleType)(state, dispatch);
            }
            return prosemirrorCommands.setBlockType(type, attrs)(state, dispatch);
        };
    };

    var toggleList = function (type, itemType) {
        return function (state, dispatch) {
            var isActive = helpers.isNodeActive(state, type);
            if (isActive) {
                return prosemirrorSchemaList.liftListItem(itemType)(state, dispatch);
            }
            return prosemirrorSchemaList.wrapInList(type)(state, dispatch);
        };
    };

    var toggleWrap = function (type) {
        return function (state, dispatch) {
            var isActive = helpers.isNodeActive(state, type);
            if (isActive) {
                return prosemirrorCommands.lift(state, dispatch);
            }
            return prosemirrorCommands.wrapIn(type)(state, dispatch);
        };
    };

    /**
     * Generated bundle index. Do not edit.
     */

    exports.toggleBlockType = toggleBlockType;
    exports.toggleList = toggleList;
    exports.toggleWrap = toggleWrap;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-editor-commands.umd.js.map
