(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('prosemirror-state'), require('prosemirror-view'), require('ngx-editor/plugins'), require('prosemirror-model'), require('prosemirror-schema-basic'), require('prosemirror-schema-list')) :
    typeof define === 'function' && define.amd ? define('ngx-editor', ['exports', '@angular/core', '@angular/forms', 'prosemirror-state', 'prosemirror-view', 'ngx-editor/plugins', 'prosemirror-model', 'prosemirror-schema-basic', 'prosemirror-schema-list'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-editor'] = {}, global.ng.core, global.ng.forms, global.prosemirrorState, global.prosemirrorView, global['ngx-editor'].plugins, global.prosemirrorModel, global.prosemirrorSchemaBasic, global.prosemirrorSchemaList));
}(this, (function (exports, i0, forms, prosemirrorState, prosemirrorView, plugins, prosemirrorModel, schemaBasic, schemaList) { 'use strict';

    var listGroup = 'block';
    var listItem = Object.assign({}, schemaList.listItem, { content: 'paragraph block*' });
    var orderedList = Object.assign({}, schemaList.orderedList, { content: 'list_item+', group: listGroup });
    var bulletList = Object.assign({}, schemaList.bulletList, { content: 'list_item+', group: listGroup });
    var nodes = Object.assign({}, schemaBasic.nodes, {
        list_item: listItem,
        ordered_list: orderedList,
        bullet_list: bulletList
    });
    var linkMark = Object.assign({}, schemaBasic.marks.link, {
        attrs: Object.assign(Object.assign({}, schemaBasic.marks.link.attrs), { target: {
                default: '_blank'
            } })
    });
    var marks = Object.assign({}, schemaBasic.marks, {
        link: linkMark
    });
    var schema = new prosemirrorModel.Schema({
        marks: marks,
        nodes: nodes
    });

    var NgxEditorServiceConfig = /** @class */ (function () {
        function NgxEditorServiceConfig() {
            this.plugins = [
                plugins.menu(),
                plugins.placeholder()
            ];
            this.nodeViews = {};
            this.schema = schema;
        }
        return NgxEditorServiceConfig;
    }());
    NgxEditorServiceConfig.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgxEditorServiceConfig_Factory() { return new NgxEditorServiceConfig(); }, token: NgxEditorServiceConfig, providedIn: "root" });
    NgxEditorServiceConfig.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    var NgxEditorService = /** @class */ (function () {
        function NgxEditorService(config) {
            this.config = config;
        }
        return NgxEditorService;
    }());
    NgxEditorService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgxEditorService_Factory() { return new NgxEditorService(i0.ɵɵinject(NgxEditorServiceConfig, 8)); }, token: NgxEditorService, providedIn: "root" });
    NgxEditorService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NgxEditorService.ctorParameters = function () { return [
        { type: NgxEditorServiceConfig, decorators: [{ type: i0.Optional }] }
    ]; };
    var defaultConfig = {
        plugins: [],
        nodeViews: {},
        schema: schema
    };
    function provideMyServiceOptions(config) {
        return Object.assign({}, defaultConfig, config);
    }

    var NgxEditorComponent = /** @class */ (function () {
        function NgxEditorComponent(ngxEditorService) {
            this.editorInitialized = false;
            this.config = ngxEditorService.config;
        }
        NgxEditorComponent.prototype.writeValue = function (value) {
            if (!this.editorInitialized) {
                return;
            }
            this.updateContent(value);
        };
        NgxEditorComponent.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        NgxEditorComponent.prototype.registerOnTouched = function () { };
        NgxEditorComponent.prototype.parseDoc = function (contentJson) {
            if (!contentJson) {
                return null;
            }
            var schema = this.config.schema;
            return schema.nodeFromJSON(contentJson);
        };
        NgxEditorComponent.prototype.updateContent = function (value) {
            try {
                var doc = this.parseDoc(value);
                var state = this.view.state;
                // don't emit if both content is same
                if (doc !== null && state.doc.eq(doc)) {
                    return;
                }
                var tr = state.tr;
                tr.replaceWith(0, state.doc.content.size, doc);
                this.view.dispatch(tr);
            }
            catch (err) {
                console.error('Unable to update document.', err);
            }
        };
        NgxEditorComponent.prototype.handleTransactions = function (tr) {
            var state = this.view.state.applyTransaction(tr).state;
            this.view.updateState(state);
            if (tr.docChanged && this.onChange) {
                var json = state.doc.toJSON();
                this.onChange(json);
            }
        };
        NgxEditorComponent.prototype.createEditor = function () {
            var _a = this.config, schema = _a.schema, plugins = _a.plugins, nodeViews = _a.nodeViews;
            this.view = new prosemirrorView.EditorView(this.ngxEditor.nativeElement, {
                state: prosemirrorState.EditorState.create({
                    schema: schema,
                    plugins: plugins
                }),
                nodeViews: nodeViews,
                dispatchTransaction: this.handleTransactions.bind(this),
                attributes: {
                    class: 'NgxEditor__Content'
                },
            });
            this.editorInitialized = true;
        };
        NgxEditorComponent.prototype.ngOnInit = function () {
            this.createEditor();
        };
        NgxEditorComponent.prototype.ngOnDestroy = function () {
            this.view.destroy();
        };
        return NgxEditorComponent;
    }());
    NgxEditorComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-editor',
                    template: "<div class=\"NgxEditor\" #ngxEditor></div>\n",
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: i0.forwardRef(function () { return NgxEditorComponent; }),
                            multi: true
                        }],
                    encapsulation: i0.ViewEncapsulation.None,
                    styles: [".NgxEditor{background:#fff;background-clip:padding-box;border:2px solid rgba(0,0,0,.2);border-radius:4px;color:#000;position:relative}.NgxEditor__MenuBar{border-bottom:1px solid #ddd;cursor:default;display:flex;height:1.85rem;padding:.2rem}.NgxEditor__MenuItem{align-items:center;border-radius:2px;display:flex;justify-content:center;position:relative}.NgxEditor__MenuItem:hover{background-color:#f1f1f1}.NgxEditor__MenuItem.NgxEditor__MenuItem--Icon{height:1.85rem;transition:.3s ease-in-out;width:1.85rem}.NgxEditor__MenuItem.NgxEditor__MenuItem--Icon+.NgxEditor__MenuItem--Icon{margin-left:2px}.NgxEditor__MenuItem .NgxEditor__MenuItem--IconContainer{display:flex}.NgxEditor__MenuItem.NgxEditor__MenuItem--Text{padding:0 .3rem}.NgxEditor__MenuItem.NgxEditor__MenuItem--Active{background-color:#e8f0fe}.NgxEditor__MenuItem.NgxEditor__MenuItem--Active.NgxEditor__MenuItem--Text{color:#1a73e8}.NgxEditor__MenuItem.NgxEditor__MenuItem--Active svg{fill:#1a73e8}.NgxEditor--Disabled{opacity:.5;pointer-events:none}.NgxEditor__Seperator{border-left:1px solid #ccc;margin:0 .3rem}.NgxEditor__Dropdown{align-items:center;display:flex;min-width:4rem;position:relative}.NgxEditor__Dropdown:hover{background-color:#f1f1f1}.NgxEditor__Dropdown .NgxEditor__Dropdown__Text{align-items:center;display:flex;padding:0 .3rem}.NgxEditor__Dropdown .NgxEditor__Dropdown__Text:after{border-bottom:0;border-left:.25rem solid transparent;border-right:.25rem solid transparent;border-top:.25rem solid;content:\"\";display:inline-block;margin-left:1.5rem;vertical-align:.25rem}.NgxEditor__Dropdown .NgxEditor__Dropdown__DropdownMenu{background-color:#fff;border-radius:4px;box-shadow:0 2px 6px 2px rgba(60,64,67,.15);display:none;left:0;position:absolute;top:calc(1.85rem + 2px);width:100%;z-index:10}.NgxEditor__Dropdown .NgxEditor__Dropdown__Item{color:inherit;padding:.5rem;white-space:nowrap}.NgxEditor__Dropdown .NgxEditor__Dropdown__Item:hover{background-color:#ececec}.NgxEditor__Dropdown.NgxEditor__Dropdown--Open,.NgxEditor__Dropdown.NgxEditor__Dropdown--Selected{background-color:#e8f0fe}.NgxEditor__Dropdown.NgxEditor__Dropdown--Open .NgxEditor__Dropdown__Text,.NgxEditor__Dropdown.NgxEditor__Dropdown--Selected .NgxEditor__Dropdown__Text{color:#1a73e8}.NgxEditor__Dropdown .NgxEditor__Dropdown--Active{background-color:#f1f1f1}.NgxEditor__Dropdown .NgxEditor__Dropdown--Active:hover{background-color:#e7e7e7}.NgxEditor__Dropdown.NgxEditor__Dropdown--Open .NgxEditor__Dropdown__DropdownMenu{display:block}.NgxEditor__Popup{background-color:#fff;border-radius:4px;box-shadow:0 2px 6px 2px rgba(60,64,67,.15);display:none;min-width:12rem;padding:8px;position:absolute;top:calc(1.85rem + 2px);z-index:10}.NgxEditor__Popup .NgxEditor__Popup--FormGroup{margin-bottom:8px}.NgxEditor__Popup .NgxEditor__Popup--FormGroup label{margin-bottom:3px}.NgxEditor__Popup .NgxEditor__Popup--FormGroup input[type=text],.NgxEditor__Popup .NgxEditor__Popup--FormGroup input[type=url]{padding:2px 4px}.NgxEditor__Popup .NgxEditor__Popup--Col{display:flex;flex-direction:column;position:relative}.NgxEditor__Popup .NgxEditor__Popup--Label{font-size:85%}.NgxEditor__Popup.NgxEditor__Popup--Open{display:block}.NgxEditor__Placeholder{color:#6c757d;opacity:1}.NgxEditor__Content{padding:.5rem;white-space:pre-wrap}.NgxEditor__Content p{margin:0 0 .7rem}.NgxEditor__Content blockquote{border-left:3px solid #ddd;margin-left:0;margin-right:0;padding-left:1rem}.NgxEditor__FloatingBubble{background:#fff;border:1px solid silver;border-radius:4px;display:flex;margin-bottom:.3rem;padding:.3rem;position:absolute;transform:translateX(-50%);z-index:20}.NgxEditor__FloatingBubble:after,.NgxEditor__FloatingBubble:before{border:solid transparent;border-width:5px 5px 0;content:\"\";height:0;left:50%;margin-left:-5px;position:absolute;width:0}.NgxEditor__FloatingBubble:before{border-top-color:silver;bottom:-6px}.NgxEditor__FloatingBubble:after{border-top-color:#fff;bottom:-4.5px}.NgxEditor__FloatingBubble a{display:inline-block;margin-left:2px;max-width:15rem;overflow:hidden;text-overflow:ellipsis}.NgxEditor__FloatingBubble .commands{display:flex;margin-left:.5rem}.NgxEditor__FloatingBubble .commands .command{border:none}.NgxEditor__FloatingBubble .commands .command:hover{text-decoration:underline}.ProseMirror{outline:none}"]
                },] }
    ];
    NgxEditorComponent.ctorParameters = function () { return [
        { type: NgxEditorService }
    ]; };
    NgxEditorComponent.propDecorators = {
        ngxEditor: [{ type: i0.ViewChild, args: ['ngxEditor', { static: true },] }]
    };

    var NGX_EDITOR_CONFIG_TOKEN = new i0.InjectionToken('NgxEditorConfig');
    var NgxEditorModule = /** @class */ (function () {
        function NgxEditorModule() {
        }
        NgxEditorModule.forRoot = function (config) {
            return {
                ngModule: NgxEditorModule,
                providers: [
                    {
                        provide: NGX_EDITOR_CONFIG_TOKEN,
                        useValue: config
                    },
                    {
                        provide: NgxEditorServiceConfig,
                        useFactory: provideMyServiceOptions,
                        deps: [NGX_EDITOR_CONFIG_TOKEN]
                    }
                ]
            };
        };
        return NgxEditorModule;
    }());
    NgxEditorModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [NgxEditorComponent],
                    exports: [NgxEditorComponent],
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgxEditorComponent = NgxEditorComponent;
    exports.NgxEditorModule = NgxEditorModule;
    exports.marks = marks;
    exports.nodes = nodes;
    exports.schema = schema;
    exports.ɵa = NgxEditorServiceConfig;
    exports.ɵb = NgxEditorService;
    exports.ɵc = provideMyServiceOptions;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-editor.umd.js.map
