import { setBlockType, lift, wrapIn } from 'prosemirror-commands';
import { isNodeActive } from 'ngx-editor/helpers';
import { liftListItem, wrapInList } from 'prosemirror-schema-list';

const toggleBlockType = (type, toggleType, attrs = {}) => {
    return (state, dispatch) => {
        const isActive = isNodeActive(state, type, attrs);
        if (isActive) {
            return setBlockType(toggleType)(state, dispatch);
        }
        return setBlockType(type, attrs)(state, dispatch);
    };
};

const toggleList = (type, itemType) => {
    return (state, dispatch) => {
        const isActive = isNodeActive(state, type);
        if (isActive) {
            return liftListItem(itemType)(state, dispatch);
        }
        return wrapInList(type)(state, dispatch);
    };
};

const toggleWrap = (type) => {
    return (state, dispatch) => {
        const isActive = isNodeActive(state, type);
        if (isActive) {
            return lift(state, dispatch);
        }
        return wrapIn(type)(state, dispatch);
    };
};

/**
 * Generated bundle index. Do not edit.
 */

export { toggleBlockType, toggleList, toggleWrap };
//# sourceMappingURL=ngx-editor-commands.js.map
